{$A+,B-,D-,E+,F-,G+,I+,L+,N-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0}
{**********************************************************}
{    Copyright (C) 1996,97 by TMT Corporation              }
{    Port by Vadim Bodrov, TMT Corp.                       }
{    Ported to ObjGfx by TCA of NewOrder (in about 20 min) }
{**********************************************************}

{ this exaple demonstrate possibility of GRAPH library  }

{ DOS version of this program has been published in                     }
{ SWAG. Here is slightly changed original version with author comments. }

{ Very primitive 3d engine                                              }
{ features: convex vectors and lambert shading..                        }
{ Under construction                                                    }
{ Coded by Archmage (sigjol@ice.is)                                     }

 uses SinCos,ObjGfx0,ObjGfx8,Keys,Font8;

 const
  pntsnr=     12;
  facenr=     20;
  polyvertnr= 3;          {nr of points in each polygon}
  distance=   4000;
  enddist=    800;
  xcenter=    0;
  ycenter=    0;          {the pos of object on the screen}
  zcenter=    0;
  xrotadd=    3;          { rotations about x,y,z axis}
  yrotadd=    4;
  zrotadd=   -2;

 { Conventional x,y,z format...}
 Verts: array [1..(pntsnr*3)] of integer=
           (200, 0, -120, 62, -189, -120, -160, -119, -120, -163, 115, -120,
            58, 191, -120, 0, 0, -243, -200, -3, 79, -62, -189, 80, -65, 188,
            80, 160, -115, 79, 160, 118, 78, -1, 0, 202);

 {Format: nr of faces; face1,face2,face3...; color;texmap info}
 { This format is compatible with 3ded}
 connect: array [1..facenr*6] of integer=
          (3,  4, 3, 8,  6, 0, 3,  6, 7, 11,  5, 0, 3,  6, 2, 7,  7, 0 ,
           3,  2, 1, 7,  7, 0 ,3,  7, 1, 9,   5, 0, 3,  7, 9, 11, 6, 0,
           3,  11, 9, 10,  24, 0,  3,  9, 0,  10, 26 ,0,  3, 9, 1,  0, 7, 0,
           3,  5, 0, 1,  7, 0, 3,  5, 1, 2,  8, 0, 3,  6, 3, 2,  6, 0,
           3,  5, 2, 3,  6, 0, 3,  4, 0, 5,  7, 0, 3,  5, 3, 4,  6, 0,
           3,  10, 0, 4,  26, 0, 3,  8, 6, 11,  6, 0, 3,  10, 8, 11,  23, 0,
           3,  10, 4, 8,  25, 0, 3,  8, 3, 6,  6, 0);

 ytopclip=    0;
 ybotclip=    200;
 norm    =    90;     {  set this to -1000 to make the object transparent...}

 type
  VecVerts = record
          x : real;
          y : real;
          z : real;
 end;

 screen_coords = record
  x : word;
  y : word;
 end;

 type NewGfx8=object(Tgfx8)
               procedure triangle(x1,y1,x2,y2,x3,y3:word;colour:byte);
               procedure filltriangle(x1,y1,x2,y2,x3,y3:word;colour:byte);
              end;
 { All the vairables declared }

 var
  polyxyz : array[1..pntsnr] of vecverts;
  polyxyzb : array[1..pntsnr] of vecverts;
  normxyz : array[1..facenr] of vecverts;
  normxyzb : array[1..facenr] of vecverts;
  scrcoords : array[1..pntsnr] of screen_coords;
  rotxyz : array [1..pntsnr] of vecverts;
  rotnxyz : array [1..facenr] of vecverts;
  xr,yr,zr : integer;

  v,loop2,dist,i,a,offs : LongInt;
  VecCol : longint;
  xadd,yadd,zadd : real;
  precsin : array[0..360] of real;
  preccos : array[0..360] of real;
  poly : array [0..199,1..2] of LongInt;

  Page:   Boolean;
  Mode3D: Byte;
  Ch:     Char;


  var screen:TScreen8;
      Font:TDPFont8;
      dbuf:NewGfx8;

procedure NewGfx8.Triangle(x1,y1,x2,y2,x3,y3:word; Colour:byte);
var points:array[1..3] of pointtype;
begin
 points[1].x:=x1;
 points[1].y:=y1;
 points[2].x:=x2;
 points[2].y:=y2;
 points[3].x:=x3;
 points[3].y:=y3;
 drawpoly(3,points,colour);
end;

procedure NewGfx8.FillTriangle(x1,y1,x2,y2,x3,y3:word; Colour:byte);
var points:array[1..3] of pointtype;
begin
 points[1].x:=x1;
 points[1].y:=y1;
 points[2].x:=x2;
 points[2].y:=y2;
 points[3].x:=x3;
 points[3].y:=y3;
 fillConvexpoly(3,Points,colour);
end;

 { This routine defines the vertices of the cube }
 { They must be in this order for calculating normals }
 procedure SetuPoints;
 begin
  i:=1;
  v:=1;
  repeat
   polyxyzb[v].x:=Verts[i];
   i:=i+1;
   polyxyzb[v].y:=Verts[i];
   i:=i+1;
   polyxyzb[v].z:=Verts[i];
   i:=i+1;
   v:=v+1;
  until v=pntsnr+1;
  for i:=1 to facenr*6 do
   connect[i]:=connect[i]+1
 end;

 procedure SetUpsc; { This creates the lookup table }
 var loop1:integer;
     ax,ay,az,bx,by,bz : real;
 begin
  offs:=0 ;
  for loop1:=0 to 360 do begin
   precsin [loop1]:=xsin(loop1);
   preccos [loop1]:=xcos(loop1);
  end;
  offs:=0 ;
  for i:=1 to facenr do begin
 {
   Here I precalculate the normals and then all
   I have to do is rotate them for each frame
 }
   ax:=(polyxyzb[connect[3+offs]].x)-(polyxyzb[connect[2+offs]].x);
   ay:=(polyxyzb[connect[3+offs]].y)-(polyxyzb[connect[2+offs]].y);
   az:=(polyxyzb[connect[3+offs]].z)-(polyxyzb[connect[2+offs]].z);
   bx:=(polyxyzb[connect[4+offs]].x)-(polyxyzb[connect[2+offs]].x);
   by:=(polyxyzb[connect[4+offs]].y)-(polyxyzb[connect[2+offs]].y);
   bz:=(polyxyzb[connect[4+offs]].z)-(polyxyzb[connect[2+offs]].z);
   normxyz[i].x:=0 ;
   normxyz[i].y:=0 ;
   normxyz[i].z:=0 ;
   normxyzb[i].x:=0 ;
   normxyzb[i].y:=0 ;
   normxyzb[i].z:=0 ;
   normxyzb[i].x:=(ay*bz)-(by*az);
   normxyzb[i].y:=(az*bx)-(bz*ax);
   normxyzb[i].z:=(ax*by)-(bx*ay);
   offs:=offs+6;
  end;
 end;

 procedure RotatePoints(xrot,yrot,zrot:integer);
 var sinxr,cosxr,sinyr,cosyr,sinzr,coszr : real;
 begin
  { here are all rotations values updated and precalculated }
  xr:=xr+xrot;
  if xr>360 then xr:=1;
  if xr<0 then xr:=360;
  yr:=yr+yrot;
  if yr>360 then yr:=1;
  if yr<0 then zr:=360;
  zr:=zr+zrot;
  if zr>360 then zr:=1;
  if zr<0 then zr:=360;
  sinxr:=precsin[xr];
  cosxr:=preccos[xr];
  sinyr:=precsin[yr];
  cosyr:=preccos[yr];
  sinzr:=precsin[zr];
  coszr:=preccos[zr];
  for i:=1 to pntsnr do begin
  { this is the formula for vector rotations around all axis in 3d space }
   rotxyz[i].x:=0;
   rotxyz[i].y:=0;
   rotxyz[i].z:=0;
   polyxyz[i].x:=0;
   polyxyz[i].y:=0;
   polyxyz[i].z:=0;
   polyxyz[i].x:=polyxyzb[i].x;
   polyxyz[i].y:=polyxyzb[i].y;
   polyxyz[i].z:=polyxyzb[i].z;
   rotxyz[i].y:=polyxyz[i].y*cosxr-polyxyz[i].z*sinxr;
   rotxyz[i].z:=polyxyz[i].z*cosxr+polyxyz[i].y*sinxr;
   polyxyz[i].y:=rotxyz[i].y;
   polyxyz[i].z:=rotxyz[i].z;
   rotxyz[i].z:=polyxyz[i].z*cosyr-polyxyz[i].x*sinyr;
   rotxyz[i].x:=polyxyz[i].x*cosyr+polyxyz[i].z*sinyr;
   polyxyz[i].x:=rotxyz[i].x;
   rotxyz[i].x:=polyxyz[i].x*coszr-polyxyz[i].y*sinzr;
   rotxyz[i].y:=polyxyz[i].y*coszr+polyxyz[i].x*sinzr;
  end;
  for i:=1 to facenr do begin
   rotnxyz[i].x:=0;
   rotnxyz[i].y:=0;
   rotnxyz[i].z:=0;
   normxyz[i].x:=normxyzb[i].x;
   normxyz[i].y:=normxyzb[i].y;
   normxyz[i].z:=normxyzb[i].z;
   rotnxyz[i].y:=normxyz[i].y*cosxr-normxyz[i].z*sinxr;
   rotnxyz[i].z:=normxyz[i].z*cosxr+normxyz[i].y*sinxr;
   normxyz[i].y:=rotnxyz[i].y;
   normxyz[i].z:=rotnxyz[i].z;
   rotnxyz[i].z:=normxyz[i].z*cosyr-normxyz[i].x*sinyr;
   rotnxyz[i].x:=normxyz[i].x*cosyr+normxyz[i].z*sinyr;
   normxyz[i].x:=rotnxyz[i].x;
   rotnxyz[i].x:=normxyz[i].x*coszr-normxyz[i].y*sinzr;
   rotnxyz[i].y:=normxyz[i].y*coszr+normxyz[i].x*sinzr;
  end;
 end;

 procedure ScrProject(xc,yc,zc:integer);
 begin
  for i:=1 to pntsnr do begin
   scrcoords[i].x:=trunc((320*(rotxyz[i].x+xc)/(dist-(rotxyz[i].z+zc)))+320);
   scrcoords[i].y:=trunc(160-(256*(rotxyz[i].y+yc)/(dist-(rotxyz[i].z+zc))));
  end;
 end;

 procedure Draw;
 begin
  offs:=-6 ;
  a:=1 ;
  for i:=1 to facenr do begin
   offs:=offs+6;
   VecCol:=trunc(rotnxyz[i].z/400);
   if rotnxyz[i].z>10000 then begin
   with dbuf do
   case Mode3D of
    0:begin
      filltriangle (scrcoords[connect[2+offs]].x-120,scrcoords[connect[2+offs]].y,
       scrcoords[connect[3+offs]].x-120,scrcoords[connect[3+offs]].y,
       scrcoords[connect[4+offs]].x-120,scrcoords[connect[4+offs]].y,VecCol);
      Inc(VecCol,100);
      filltriangle (scrcoords[connect[2+offs]].x+120,scrcoords[connect[2+offs]].y,
       scrcoords[connect[3+offs]].x+120,scrcoords[connect[3+offs]].y,
       scrcoords[connect[4+offs]].x+120,scrcoords[connect[4+offs]].y,VecCol);
      end;
    1:begin
      triangle (scrcoords[connect[2+offs]].x-120,scrcoords[connect[2+offs]].y,
       scrcoords[connect[3+offs]].x-120,scrcoords[connect[3+offs]].y,
       scrcoords[connect[4+offs]].x-120,scrcoords[connect[4+offs]].y,VecCol);
      Inc(VecCol,100);
      triangle (scrcoords[connect[2+offs]].x+120,scrcoords[connect[2+offs]].y,
       scrcoords[connect[3+offs]].x+120,scrcoords[connect[3+offs]].y,
       scrcoords[connect[4+offs]].x+120,scrcoords[connect[4+offs]].y,VecCol);
      end;
    2:begin
      triangle (scrcoords[connect[2+offs]].x-120,scrcoords[connect[2+offs]].y,
       scrcoords[connect[3+offs]].x-120,scrcoords[connect[3+offs]].y,
       scrcoords[connect[4+offs]].x-120,scrcoords[connect[4+offs]].y,VecCol);
      Inc(VecCol,100);
      filltriangle (scrcoords[connect[2+offs]].x+120,scrcoords[connect[2+offs]].y,
       scrcoords[connect[3+offs]].x+120,scrcoords[connect[3+offs]].y,
       scrcoords[connect[4+offs]].x+120,scrcoords[connect[4+offs]].y,VecCol);
      end;
    3:begin
      Filltriangle (scrcoords[connect[2+offs]].x-120,scrcoords[connect[2+offs]].y,
       scrcoords[connect[3+offs]].x-120,scrcoords[connect[3+offs]].y,
       scrcoords[connect[4+offs]].x-120,scrcoords[connect[4+offs]].y,VecCol);
      Inc(VecCol,100);
      triangle (scrcoords[connect[2+offs]].x+120,scrcoords[connect[2+offs]].y,
       scrcoords[connect[3+offs]].x+120,scrcoords[connect[3+offs]].y,
       scrcoords[connect[4+offs]].x+120,scrcoords[connect[4+offs]].y,VecCol);
      end;
    end;
   end;
  end;
 end;

var wfr:boolean;

 { Here is the main program }
 begin
 { global variables initialized }
  loop2:=1;
  SetuPoints;                   { define vector vertices }
  SetupSc;
  Dist:=2000;
  wfr:=false;

  Dbuf.init;
  if not dbuf.getmem(640,300) then
   begin
    writeln('Error allocating double buffer');
    halt
   end;
  Screen.init;
  Screen.SetMode(_640x480x8bpp);
  Font.Init(Screen);
  Font.Load('ROM8X14.DPF');

  with screen, Font do
   begin
    for i:=1 to 126 do SetRGBPalette (i,i div 5,i div 3,(20+i) div 3);
    for i:=1 to 126 do SetRGBPalette (120+i,i div 5,(20+i) div 3,i div 3);
    horizline(0,getmaxx,0,235);
    for i:=0 to getmaxy do
     begin
      putpixel(0,i,245-(i shr 2));
      putpixel(getmaxx,i,245-(i shr 2));
     end;
    horizline(0,getmaxx,getmaxy,245-120);
    SetColor(115);

    CenterTextX(20,'VBE Mode 101h (SVGA 640x480x256)');
    SetColor(120);

    CenterTextX(320,'Use "M" key to define view mode');
    SetColor(215);

    CenterTextX(340,'Use "+" and "-" to adjust distance');
    SetColor(220);

    CenterTextX(360,'Use "TAB" to toggle Wait For Retrace');

    SetColor(225);
    CenterTextX(380,'Use "ESC" to exit');
   end;

  repeat
   if dist<enddist then dist:=enddist;
    rotatepoints (xrotadd,yrotadd,zrotadd);  { rotate around x,y,z axis }
   scrproject(xcenter,ycenter,zcenter);
   if wfr then screen.waitforretrace;
   screen.copybuf(76,60,dbuf,76,60,556,256);
   dbuf.Bar(76,60,556,256,0);
   Draw;
   if KeyPressed then begin
    ch:=upcase(ReadKey);
    if (ch=#9) then wfr:=wfr xor true;
    if (ch='M') then begin
     inc(Mode3D);
     if Mode3D=4 then Mode3D:=0;
    end;
{    if (ch=' ') then readkey;}
    if (ch in ['+','=']) then dec(Dist,50);
    if (ch='-') then inc(Dist,50);
    if Dist>Distance then Dist:=Distance;
    if Dist<EndDist then Dist:=EndDist;
   end;
  until ch=#27;
  dbuf.done;
  screen.done;
 end.